var app;
var appFocussedCtrl = null;

function init() {
    app = new lge();
    app.createImgViewer($("#myGallery"), true, clearMainFocus);
    bindEvents();
    $('#myGallery').addClass("myGalleryFocus");
    appFocussedCtrl = "myGallery";
    var elem = document.getElementById("myGallery");
    elem.addEventListener("mousewheel", app.mouseWheel, false);
}

function bindEvents() {
    $(document).keydown(function(event) {
        var key = event.keycode || event.which;
        handleKeyDown(key);
    });
    $('#closeBtn').mouseenter(function(e) {
        handleMouseEnter(this);
    });
    $('#closeBtn').click(function(e) {
        handleClick(this);
    });

    $('#returnBtn').mouseenter(function(e) {
        handleMouseEnter(this);
    });
    $('#returnBtn').click(function(e) {
        handleClick(this);
    });

    $('#addImgBtn').mouseenter(function(e) {
        handleMouseEnter(this);
    });
    $('#addImgBtn').click(function(e) {
        handleClick(this);
    });

    $('#removeImgBtn').mouseenter(function(e) {
        handleMouseEnter(this);
    });
    $('#removeImgBtn').click(function(e) {
        handleClick(this);
    });

    $('#goToImgBtn').mouseenter(function(e) {
        handleMouseEnter(this);
    });
    $('#goToImgBtn').click(function(e) {
        handleClick(this);
    });

    $('#myGallery').mouseenter(function(e) {
        handleMouseEnter(this);
    });
}

function handleMouseEnter(element) {
    clearPreviousFocus();
    appFocussedCtrl = $(element).attr("id");

    switch (appFocussedCtrl) {
    case "myGallery":
        $(element).addClass("myGalleryFocus");
        app.setFrameworkFocus("down");
        break;
    case "closeBtn":
    case "returnBtn":
    case "addImgBtn":
    case "removeImgBtn":
    case "goToImgBtn":
        $("#myGallery").removeClass("myGalleryFocus");
        $(element).removeClass("btn_default").addClass("btn_focus");
        break;
    }
}

function handleClick(element) {
    var id = $(element).attr("id");
    switch (id) {
    case "myGallery":
        app.doSelection();
        break;
    case "closeBtn":
        if (window.NetCastExit) {
            window.NetCastExit();
        }
        break;
    case "returnBtn":
        if (window.NetCastBack) {
            window.NetCastBack();
        }
        break;
    case "addImgBtn":
        app.addImage("images/television.jpg");
        $("#myGallery").removeClass("myGalleryFocus");
        app.removeFrameworkFocus();
        break;
    case "removeImgBtn":
        app.removeImage();
        $("#myGallery").removeClass("myGalleryFocus");
        app.removeFrameworkFocus();
        break;
    case "goToImgBtn":
        app.gotoImage(2);
        $("#myGallery").removeClass("myGalleryFocus");
        app.removeFrameworkFocus();
        break;
    }

}

function handleKeyDown(key) {
    switch (key) {
    case VK_BACK:
        if (window.NetCastBack) {
            window.NetCastBack();
        }
        break;
    case VK_RIGHT:
        if ($("#" + appFocussedCtrl).hasClass("myGalleryFocus")) {
            app.focusNext();
        } else {
            if (appFocussedCtrl == "removeImgBtn") {
                clearPreviousFocus();
                appFocussedCtrl = "goToImgBtn";
                $("#" + appFocussedCtrl).removeClass("btn_default").addClass("btn_focus");

            } else if (appFocussedCtrl == "addImgBtn") {
                clearPreviousFocus();
                appFocussedCtrl = "removeImgBtn";
                $("#" + appFocussedCtrl).removeClass("btn_default").addClass("btn_focus");

            } else if (appFocussedCtrl == "returnBtn") {
                clearPreviousFocus();
                appFocussedCtrl = "closeBtn";
                $("#" + appFocussedCtrl).removeClass("btn_default").addClass("btn_focus");
            }
        }

        break;
    case VK_LEFT:
        if ($("#" + appFocussedCtrl).hasClass("myGalleryFocus")) {
            app.focusPrevious();
        } else {
            if (appFocussedCtrl == "goToImgBtn") {
                clearPreviousFocus();
                appFocussedCtrl = "removeImgBtn";
                $("#" + appFocussedCtrl).removeClass("btn_default").addClass("btn_focus");
            } else if (appFocussedCtrl == "removeImgBtn") {
                clearPreviousFocus();
                appFocussedCtrl = "addImgBtn";
                $("#" + appFocussedCtrl).removeClass("btn_default").addClass("btn_focus");
            } else if (appFocussedCtrl == "closeBtn") {
                clearPreviousFocus();
                appFocussedCtrl = "returnBtn";
                $("#" + appFocussedCtrl).removeClass("btn_default").addClass("btn_focus");
            }
        }

        break;
    case VK_UP:
        if ($("#" + appFocussedCtrl).hasClass("myGalleryFocus")) {
            if (app.focusUp() == false && app.getDisplayMode() == "Normal") {
                clearPreviousFocus();
                appFocussedCtrl = "addImgBtn";
                $("#" + appFocussedCtrl).removeClass("btn_default").addClass("btn_focus");
            }
        } else if (appFocussedCtrl == "addImgBtn" || appFocussedCtrl == "removeImgBtn" || appFocussedCtrl == "goToImgBtn") {

            clearPreviousFocus();
            appFocussedCtrl = "returnBtn";
            $("#" + appFocussedCtrl).removeClass("btn_default").addClass("btn_focus");

        }
        break;
    case VK_DOWN:
        if ($("#" + appFocussedCtrl).hasClass("myGalleryFocus")) {
            app.focusDown();
        } else {
            if (appFocussedCtrl == "returnBtn" || appFocussedCtrl == "closeBtn") {
                clearPreviousFocus();
                appFocussedCtrl = "addImgBtn";
                $("#" + appFocussedCtrl).removeClass("btn_default").addClass("btn_focus");
            } else if (appFocussedCtrl == "addImgBtn" || appFocussedCtrl == "removeImgBtn" || appFocussedCtrl == "goToImgBtn") {
                clearPreviousFocus();
                appFocussedCtrl = "myGallery";
                $("#" + appFocussedCtrl).addClass("myGalleryFocus");
                app.setFrameworkFocus("down");
            }
        }
        break;
    case VK_ENTER:
        doSelection();
        break;
    }
}

function doSelection() {
    switch (appFocussedCtrl) {
    case "myGallery":
        app.doSelection();
        break;
    case "closeBtn":
        if (window.NetCastExit) {
            window.NetCastExit();
        }
        break;
    case "returnBtn":
        if (window.NetCastBack) {
            window.NetCastBack();
        }
        break;
    case "addImgBtn":
        app.addImage("images/television.jpg");
        app.removeFrameworkFocus();
        break;
    case "removeImgBtn":
        app.removeImage();
        app.removeFrameworkFocus();
        break;
    case "goToImgBtn":
        app.gotoImage(2);
        app.removeFrameworkFocus();
        break;
    }
}

function clearPreviousFocus() {
    switch (appFocussedCtrl) {
    case "myGallery":
        app.removeFrameworkFocus();
        break;
    case "closeBtn":
    case "returnBtn":
    case "addImgBtn":
    case "removeImgBtn":
    case "goToImgBtn":
        $("#" + appFocussedCtrl).removeClass("btn_focus").addClass("btn_default");
        break;
    }

}

function clearMainFocus() {
    $("#" + appFocussedCtrl).removeClass("btn_focus").addClass("btn_default");
    appFocussedCtrl = "myGallery";
    $("#myGallery").addClass("myGalleryFocus");
}